// $Id$

/***************************************************************************
 *   Copyright (C) 2004 by Thomas Fischer                                  *
 *   fischer@unix-ag.uni-kl.de                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <bibtexencoder.h>
#include "bibtexstring.h"

BibTeXString::BibTeXString( const QString &id, const QString &value, QObject *parent, const char *name )
        : BibTeXElement( parent, name ), id_( id ), value_( BibTeXEncoder::currentBibTeXEncoder() ->decode( value ) )
{}


BibTeXString::~BibTeXString()
{}

void BibTeXString::setId( const QString &id )
{
    id_ = id;
}
QString BibTeXString::id()

{
    return id_;
}
void BibTeXString::setValue( const QString &value )
{
    value_ = BibTeXEncoder::currentBibTeXEncoder() ->decode( value );
}
QString BibTeXString::value()
{
    return value_;
}

QString BibTeXString::toBibTeXString( BibTeXFile::Encoding encoding )
{
    if ( encoding == BibTeXFile::encLaTeX )
        return QString( "@string { " ).append( id_ ).append( " = \"" ).append( BibTeXEncoder::currentBibTeXEncoder() ->encode( value_ ) ).append( "\" }" );
    else if ( encoding == BibTeXFile::encUTF8 )
        return QString( "@string { " ).append( id_ ).append( " = \"" ).append( value_ ).append( "\" }" );
    else
        return QString::null;
}

BibTeXElement::ElementType BibTeXString::elementType()
{
    return BibTeXElement::etString;
}

#include "bibtexstring.moc"
