/***************************************************************************
*   Copyright (C) 2004 by Thomas Fischer                                  *
*   fischer@unix-ag.uni-kl.de                                             *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/
#ifndef KBIBTEXEDITLISTBOX_H
#define KBIBTEXEDITLISTBOX_H

#include <qwidget.h>

class QListBox;
class QPushButton;
class QStringList;
class QString;
class QLabel;
class QLineEdit;

/**
@author Thomas Fischer
*/
class KBibTeXEditListBox : public QWidget
{
    Q_OBJECT

public:
    KBibTeXEditListBox( const QString& textLabel, QWidget *parent = 0, const char *name = 0 );

    enum buttons {Add, Modify, Delete, Up, Down};

    QStringList lines() const;
    void setLines( const QStringList &lines );

    void setButtonText( buttons button, const QString& text );

private slots:
    void slotLineEditTextChanged();
    void slotPushButtonAddClicked();
    void slotPushButtonModifyClicked();
    void slotPushButtonDeleteClicked();
    void slotPushButtonUpClicked();
    void slotPushButtonDownClicked();
    void slotListBoxHighlighted();

private:
    QLabel *label;
    QLineEdit *lineEditInput;
    QListBox *listBox;
    QPushButton *pushButtonAdd;
    QPushButton *pushButtonModify;
    QPushButton *pushButtonDelete;
    QPushButton *pushButtonUp;
    QPushButton *pushButtonDown;

    void updateUI();
};

#endif
