/***************************************************************************
*   Copyright (C) 2004 by Thomas Fischer                                  *
*   fischer@unix-ag.uni-kl.de                                             *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/
#ifndef KBIBTEXFILE_H
#define KBIBTEXFILE_H

#include <settings.h>
#include <bibtexfile.h>

class QWaitCondition;
class QProcess;
class KURL;
class KBibTeXListView;

/**
@author Thomas Fischer
*/
class KBibTeXFile : public BibTeXFile
{
    Q_OBJECT
public:
    enum FileType { ftPDF, ftPS };

    KBibTeXFile( QObject *parent = 0, const char *name = 0 );

    ~KBibTeXFile();

    void reorderElements( KBibTeXListView *lv );

    bool exportAs( KBibTeXFile::FileType fileType, KURL& filename, QWidget*window ) ;

private:
    QWaitCondition *wc;
    QProcess * process;

    bool exportAsPS( KURL& filename, QWidget*window );
    bool exportAsPDF( KURL& filename, QWidget*window );
    bool writeLatexFile( QString &filename );
    bool runProcess( const QDir& tempDir, const QStringList &args );
    bool runProcesses( const QDir& tempDir, const QStringList &commandLines, QWidget*window );

private slots:
    void slotProcessExited();
    void slotCancelProcess();
};

#endif
