/***************************************************************************
*   Copyright (C) 2004 by Thomas Fischer                                  *
*   fischer@unix-ag.uni-kl.de                                             *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/
#include <qlayout.h>
#include <qcheckbox.h>
#include <klocale.h>
#include <kdialog.h>

#include "settings.h"
#include "kbibtexsettingsediting.h"

KBibTeXSettingsEditing::KBibTeXSettingsEditing( QWidget *parent, const char *name )
        : QWidget( parent, name )
{
    QVBoxLayout * layout = new QVBoxLayout( this, 0, KDialog::spacingHint() );
    cbEnableAllFields = new QCheckBox( i18n( "Enable all &fields for editing" ), this );
    layout->addWidget( cbEnableAllFields );

    layout->addStretch( 1 );

    connect( cbEnableAllFields, SIGNAL( toggled( bool ) ), this, SLOT( slotConfigChanged() ) );
}


KBibTeXSettingsEditing::~KBibTeXSettingsEditing()
{
    //TODO
}

void KBibTeXSettingsEditing::applyData()
{
    kbibtexsettings.enableallfields = cbEnableAllFields->isChecked();
}

void KBibTeXSettingsEditing::setData()
{
    cbEnableAllFields->setChecked( kbibtexsettings.enableallfields );
}

void KBibTeXSettingsEditing::slotConfigChanged()
{
    emit configChanged();
}

#include "kbibtexsettingsediting.moc"
